Scala Standard Library2.13.0 < Back


# Packages

-  package root

  This is the documentation for the Scala standard library.

  This is the documentation for the Scala standard library.

  #### Package structure

  The scala package contains core types like `Int`, `Float`, `Array` or `Option` which are accessible in all Scala compilation units without explicit qualification or imports.

  Notable packages include:

  - `scala.collection` and its sub-packages contain Scala's collections framework
    - `scala.collection.immutable` - Immutable, sequential data-structures such as `Vector`, `List`, `Range`, `HashMap` or `HashSet`
    - `scala.collection.mutable` - Mutable, sequential data-structures such as `ArrayBuffer`, `StringBuilder`, `HashMap` or `HashSet`
    - `scala.collection.concurrent` - Mutable, concurrent data-structures such as `TrieMap`
  - `scala.concurrent` - Primitives for concurrent programming such as `Futures` and `Promises`
  - `scala.io` - Input and output operations
  - `scala.math` - Basic math functions and additional numeric types like `BigInt` and `BigDecimal`
  - `scala.sys` - Interaction with other processes and the operating system
  - `scala.util.matching` - Regular expressions

  Other packages exist. See the complete list on the right.

  Additional parts of the standard library are shipped as separate libraries. These include:

  - `scala.reflect` - Scala's reflection API (scala-reflect.jar)
  - `scala.xml` - XML parsing, manipulation, and serialization (scala-xml.jar)
  - `scala.collection.parallel` - Parallel collections (scala-parallel-collections.jar)
  - `scala.util.parsing` - Parser combinators (scala-parser-combinators.jar)
  - `scala.swing` - A convenient wrapper around Java's GUI framework called Swing (scala-swing.jar)

  #### Automatic imports

  Identifiers in the scala package and the `scala.Predef` object are always in scope by default.

  Some of these identifiers are type aliases provided as shortcuts to commonly used classes. For example, `List` is an alias for `scala.collection.immutable.List`.

  Other aliases refer to classes provided by the underlying platform. For example, on the JVM, `String` is an alias for `java.lang.String`.

  Definition Classes
    root
-  package scala

  Core Scala types.

  Core Scala types. They are always available without an explicit import.

  Definition Classes
    root
-  package collection
  Definition Classes
    scala
-  object ClassTagSeqFactory extends java.io.Serializable
  Definition Classes
    collection
- AnySeqDelegate
- Delegate

c

scala.collection.ClassTagSeqFactory

# AnySeqDelegate

###

#### class AnySeqDelegate[CC[A] <: SeqOps[A, Seq, Seq[A]]] extends AnyIterableDelegate[CC] with SeqFactory[CC]

A SeqFactory that uses ClassTag.Any as the evidence for every element type. This may or may not be sound depending on the use of the `ClassTag` by the collection implementation.

Annotations
  @SerialVersionUID()
Source
  Factory.scala

Linear Supertypes
SeqFactory[CC], AnyIterableDelegate[CC], IterableFactory[CC], java.io.Serializable, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. AnySeqDelegate
2. SeqFactory
3. AnyIterableDelegate
4. IterableFactory
5. Serializable
6. AnyRef
7. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new AnySeqDelegate(delegate: ClassTagSeqFactory[CC])

### Value Members

1.  final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any
2.  final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from AnySeqDelegate[CC] toany2stringadd[AnySeqDelegate[CC]] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (AnySeqDelegate[CC], B)
   Implicit
     This member is added by an implicit conversion from AnySeqDelegate[CC] toArrowAssoc[AnySeqDelegate[CC]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any
6.  def apply[A](elems: A*): CC[A]

   Creates a collection with the specified elements.

   Creates a collection with the specified elements.

   A

     the type of the collection's elements

   elems

     the elements of the created collection

   returns

     a new collection with elements `elems`

   Definition Classes
     AnyIterableDelegate → IterableFactory
7.  final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

8.  def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
   Note

     not specified by SLS as a member of AnyRef

9.  def concat[A](xss: Iterable[A]*): CC[A]

   Concatenates all argument collections into a single collection.

   Concatenates all argument collections into a single collection.

   xss

     the collections that are to be concatenated.

   returns

     the concatenation of all the collections.

   Definition Classes
     IterableFactory
10.  def empty[A]: CC[A]

    An empty collection

    An empty collection

    A

      the type of the collection's elements

    Definition Classes
      AnyIterableDelegate → IterableFactory
11.  def ensuring(cond: (AnySeqDelegate[CC]) => Boolean, msg: => Any): AnySeqDelegate[CC]
    Implicit
      This member is added by an implicit conversion from AnySeqDelegate[CC] toEnsuring[AnySeqDelegate[CC]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: (AnySeqDelegate[CC]) => Boolean): AnySeqDelegate[CC]
    Implicit
      This member is added by an implicit conversion from AnySeqDelegate[CC] toEnsuring[AnySeqDelegate[CC]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean, msg: => Any): AnySeqDelegate[CC]
    Implicit
      This member is added by an implicit conversion from AnySeqDelegate[CC] toEnsuring[AnySeqDelegate[CC]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  def ensuring(cond: Boolean): AnySeqDelegate[CC]
    Implicit
      This member is added by an implicit conversion from AnySeqDelegate[CC] toEnsuring[AnySeqDelegate[CC]] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    Tests whether the argument (`that`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
16.  def equals(arg0: AnyRef): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any
17.  def fill[A](n: Int)(elem: => A): CC[A]

    Produces a collection containing the results of some element computation a number of times.

    Produces a collection containing the results of some element computation a number of times.

    n

      the number of elements contained in the collection.

    elem

      the element computation

    returns

      A collection that contains the results of `n` evaluations of `elem`.

    Definition Classes
      AnyIterableDelegate → IterableFactory
18.  def fill[A](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(elem: => A): CC[CC[CC[CC[CC[A]]]]]

    Produces a five-dimensional collection containing the results of some element computation a number of times.

    Produces a five-dimensional collection containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    n4

      the number of elements in the 4th dimension

    n5

      the number of elements in the 5th dimension

    elem

      the element computation

    returns

      A collection that contains the results of `n1 x n2 x n3 x n4 x n5` evaluations of `elem`.

    Definition Classes
      IterableFactory
19.  def fill[A](n1: Int, n2: Int, n3: Int, n4: Int)(elem: => A): CC[CC[CC[CC[A]]]]

    Produces a four-dimensional collection containing the results of some element computation a number of times.

    Produces a four-dimensional collection containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    n4

      the number of elements in the 4th dimension

    elem

      the element computation

    returns

      A collection that contains the results of `n1 x n2 x n3 x n4` evaluations of `elem`.

    Definition Classes
      IterableFactory
20.  def fill[A](n1: Int, n2: Int, n3: Int)(elem: => A): CC[CC[CC[A]]]

    Produces a three-dimensional collection containing the results of some element computation a number of times.

    Produces a three-dimensional collection containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    elem

      the element computation

    returns

      A collection that contains the results of `n1 x n2 x n3` evaluations of `elem`.

    Definition Classes
      IterableFactory
21.  def fill[A](n1: Int, n2: Int)(elem: => A): CC[CC[A]]

    Produces a two-dimensional collection containing the results of some element computation a number of times.

    Produces a two-dimensional collection containing the results of some element computation a number of times.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    elem

      the element computation

    returns

      A collection that contains the results of `n1 x n2` evaluations of `elem`.

    Definition Classes
      IterableFactory
22.  def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
    Note

      not specified by SLS as a member of AnyRef

23.  def formatted(fmtstr: String): String

    Returns string formatted according to given `format` string.

    Returns string formatted according to given `format` string. Format strings are as for `String.format` (@see java.lang.String.format).

    Implicit
      This member is added by an implicit conversion from AnySeqDelegate[CC] toStringFormat[AnySeqDelegate[CC]] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
24.  def from[A](it: IterableOnce[A]): CC[A]

    Creates a target collection from an existing source collection

    Creates a target collection from an existing source collection

    A

      the type of the collection’s elements

    returns

      a new collection with the elements of `source`

    Definition Classes
      AnyIterableDelegate → IterableFactory
25.  final def getClass(): Class[_ <: AnyRef]

    Returns the runtime class representation of the object.

    Returns the runtime class representation of the object.

    returns

      a class object corresponding to the runtime type of the receiver.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
26.  def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any
    Annotations
      @native()
27.  final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any
28.  implicit def iterableFactory[A]: Factory[A, CC[A]]
    Definition Classes
      IterableFactory
29.  def iterate[A](start: A, len: Int)(f: (A) => A): CC[A]

    Produces a collection containing repeated applications of a function to a start value.

    Produces a collection containing repeated applications of a function to a start value.

    start

      the start value of the collection

    len

      the number of elements contained in the collection

    f

      the function that's repeatedly applied

    returns

      a collection with `len` values in the sequence `start, f(start), f(f(start)), ...`

    Definition Classes
      AnyIterableDelegate → IterableFactory
30.  final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef
31.  def newBuilder[A]: Builder[A, CC[A]]

    A

      the type of the collection’s elements

    returns

      A builder for `Iterable` objects.

    Definition Classes
      AnyIterableDelegate → IterableFactory
32.  final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

33.  final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Annotations
      @native()
    Note

      not specified by SLS as a member of AnyRef

34.  def range[A](start: A, end: A, step: A)(implicit i: Integral[A]): CC[A]

    Produces a collection containing equally spaced values in some integer interval.

    Produces a collection containing equally spaced values in some integer interval.

    start

      the start value of the collection

    end

      the end value of the collection (the first value NOT contained)

    step

      the difference between successive elements of the collection (must be positive or negative)

    returns

      a collection with values `start, start + step, ...` up to, but excluding `end`

    Definition Classes
      AnyIterableDelegate → IterableFactory
35.  def range[A](start: A, end: A)(implicit i: Integral[A]): CC[A]

    Produces a collection containing a sequence of increasing of integers.

    Produces a collection containing a sequence of increasing of integers.

    start

      the first element of the collection

    end

      the end value of the collection (the first value NOT contained)

    returns

      a collection with values `start, start + 1, ..., end - 1`

    Definition Classes
      AnyIterableDelegate → IterableFactory
36.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
37.  def tabulate[A](n: Int)(f: (Int) => A): CC[A]

    Produces a collection containing values of a given function over a range of integer values starting from 0.

    Produces a collection containing values of a given function over a range of integer values starting from 0.

    n

      The number of elements in the collection

    f

      The function computing element values

    returns

      A collection consisting of elements `f(0), ..., f(n -1)`

    Definition Classes
      AnyIterableDelegate → IterableFactory
38.  def tabulate[A](n1: Int, n2: Int, n3: Int, n4: Int, n5: Int)(f: (Int, Int, Int, Int, Int) => A): CC[CC[CC[CC[CC[A]]]]]

    Produces a five-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    Produces a five-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    n4

      the number of elements in the 4th dimension

    n5

      the number of elements in the 5th dimension

    f

      The function computing element values

    returns

      A collection consisting of elements `f(i1, i2, i3, i4, i5)` for `0 <= i1 < n1`, `0 <= i2 < n2`, `0 <= i3 < n3`, `0 <= i4 < n4`, and `0 <= i5 < n5`.

    Definition Classes
      IterableFactory
39.  def tabulate[A](n1: Int, n2: Int, n3: Int, n4: Int)(f: (Int, Int, Int, Int) => A): CC[CC[CC[CC[A]]]]

    Produces a four-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    Produces a four-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    n4

      the number of elements in the 4th dimension

    f

      The function computing element values

    returns

      A collection consisting of elements `f(i1, i2, i3, i4)` for `0 <= i1 < n1`, `0 <= i2 < n2`, `0 <= i3 < n3`, and `0 <= i4 < n4`.

    Definition Classes
      IterableFactory
40.  def tabulate[A](n1: Int, n2: Int, n3: Int)(f: (Int, Int, Int) => A): CC[CC[CC[A]]]

    Produces a three-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    Produces a three-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    n3

      the number of elements in the 3rd dimension

    f

      The function computing element values

    returns

      A collection consisting of elements `f(i1, i2, i3)` for `0 <= i1 < n1`, `0 <= i2 < n2`, and `0 <= i3 < n3`.

    Definition Classes
      IterableFactory
41.  def tabulate[A](n1: Int, n2: Int)(f: (Int, Int) => A): CC[CC[A]]

    Produces a two-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    Produces a two-dimensional collection containing values of a given function over ranges of integer values starting from 0.

    n1

      the number of elements in the 1st dimension

    n2

      the number of elements in the 2nd dimension

    f

      The function computing element values

    returns

      A collection consisting of elements `f(i1, i2)` for `0 <= i1 < n1` and `0 <= i2 < n2`.

    Definition Classes
      IterableFactory
42.  def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any
43.  final def unapplySeq[A](x: CC[A]): UnapplySeqWrapper[A]
    Definition Classes
      SeqFactory
44.  def unfold[A, S](init: S)(f: (S) => Option[(A, S)]): CC[A]

    Produces a collection that uses a function `f` to produce elements of type `A` and update an internal state of type `S`.

    Produces a collection that uses a function `f` to produce elements of type `A` and update an internal state of type `S`.

    A

      Type of the elements

    S

      Type of the internal state

    init

      State initial value

    f

      Computes the next element (or returns `None` to signal the end of the collection)

    returns

      a collection that produces elements using `f` until `f` returns `None`

    Definition Classes
      AnyIterableDelegate → IterableFactory
45.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
46.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
47.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (AnySeqDelegate[CC], B)
   Implicit
     This member is added by an implicit conversion from AnySeqDelegate[CC] toArrowAssoc[AnySeqDelegate[CC]] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from SeqFactory[CC]

### Inherited from AnyIterableDelegate[CC]

### Inherited from IterableFactory[CC]

### Inherited from java.io.Serializable

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromAnySeqDelegate[CC] to any2stringadd[AnySeqDelegate[CC]]

### Inherited by implicit conversion StringFormat fromAnySeqDelegate[CC] to StringFormat[AnySeqDelegate[CC]]

### Inherited by implicit conversion Ensuring fromAnySeqDelegate[CC] to Ensuring[AnySeqDelegate[CC]]

### Inherited by implicit conversion ArrowAssoc fromAnySeqDelegate[CC] to ArrowAssoc[AnySeqDelegate[CC]]

### Ungrouped